#define SIZE 8192

#ifndef DLGCOPY2_H
#define DLGCOPY2_H

#include <qwidget.h>
#include <qdialog.h>
#include "kcommander.h"
#include "progress.h"

class dlgCopy2 : public QDialog  {
   Q_OBJECT
public: 
	dlgCopy2(
							listView *,		// SourceListview, nicht LINKS !
					  		listView *,		// DestListview
					  		const char *,	// SourcePath
			  				const char *,	// DestPath
					  		QWidget *parent=0, const char *name=0);
	
	void					readDir(const char *path);
	~dlgCopy2();
public:		// Variablen

	myProgress        *prog1,
	                  *prog2;
	
	QString 			   sourcePath,destPath;
	listView			   *sourceLV,*destLV;
   QPushButton 	   *button;
   QLabel				*lVon,*lNach;
   bool					ABBRUCH;
 	QStrList			   fileList;
   int					fileCounter;
   int					sizeCounter;
   char 					*memory[SIZE];
   bool					overwriteFiles;
   QWidget    *main;
   		
public slots:
	void 	timerEvent(QTimerEvent *);
	void	btClicked();
};

#endif





