#include "dlgextract.h"

dlgExtract::dlgExtract(listView *lv, listView *dv,const char *zielpfad,QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	Quellpfad = lv->dirPath;
	Zielpfad = zielpfad; //dv->dirPath;
	quellLV = lv;
	zielLV = dv;
	startTimer(100);
   main = (KCommanderApp *)parent;
}

dlgExtract::~dlgExtract(){
}

void dlgExtract::timerEvent(QTimerEvent *e)
{
   killTimers();
   doIt();
}

void dlgExtract::doIt()
{
   QString archiveName;
//   QDir d;
//   debug(Zielpfad);
   if(Zielpfad == ".") Zielpfad = "";
   chdir(Zielpfad);
//   debug("Wechsle nach " + Zielpfad);
   listItem *li;
if(quellLV->itemsSelected() != 0)
{
   while(quellLV->itemsSelected() != 0)
   {
      li = quellLV->Liste;
      while(!li->selected)
         li=li->next;
      archiveName = Quellpfad + *li->text[0];

      {
   		QString Packer="", Parameter="";
   		if(archiveName.right(4) == ".tgz")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfz";
   		}
   		if(archiveName.right(4) == ".tar")
   		{
   		   Packer ="tar";
   		   Parameter = "xvf";
   		}
   		if(archiveName.right(6) == "tar.gz")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfz";
   		}
   		if(archiveName.right(4) == ".bz2")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfI";
   		}
   		if(archiveName.right(2) == ".Z")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfZ";
   		}
   		if(archiveName.right(4) == ".zip")
   		{
   		   Packer ="unzip";
   		   Parameter = "-o";
   		}
   		if(archiveName.right(4) == ".rar")
   		{
   		   Packer ="unrar";
   		   Parameter = "";
   		}
   		if(archiveName.right(4) == ".ace")
   		{
   		   Packer ="unace";
   		   Parameter = "";
   		}
//         debug(Packer);
         if(Packer.length() != 0)
   		{
      	   	
//      	   	debug("Fange an zu entpacken !");
      	   	KShellProcess proc;
   	      	proc << Packer;                           // welcher Packer wird benutzt ??
	   	      proc << Parameter;                        // eventuelle Parameter
   	   	   proc << tools::convertPfad(archiveName);  // der Linuxkonforme Dateiname
   	   	
   	   	   QApplication::connect(&proc, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
      	   	QApplication::connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
	      	   QApplication::connect(&proc, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
	      	   READY = false;
   		      proc.start(KProcess::Block,KProcess::All);
   		      while(!READY)
   		      {
   		         kapp->processEvents();
   		         kapp->processEvents();
   		         kapp->processEvents();
   		         kapp->processEvents();
   		      }
   		}
   		else
   		{
   		   debug(archiveName + "\tUnbekanntes Archiveformat !");
   		}
      }
      li->selected = false;
      quellLV->refreshOneLine(li);
      kapp->processEvents();
   }
}
else
{
   li = quellLV->lastItemClicked;
   archiveName = Quellpfad + *li->text[0];

      {
   		QString Packer="", Parameter="";
   		if(archiveName.right(4) == ".tgz")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfz";
   		}
   		if(archiveName.right(4) == ".tar")
   		{
   		   Packer ="tar";
   		   Parameter = "xvf";
   		}
   		if(archiveName.right(6) == "tar.gz")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfz";
   		}
   		if(archiveName.right(4) == ".bz2")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfI";
   		}
   		if(archiveName.right(2) == ".Z")
   		{
   		   Packer ="tar";
   		   Parameter = "xvfZ";
   		}
   		if(archiveName.right(4) == ".zip")
   		{
   		   Packer ="unzip";
   		   Parameter = "-o";
   		}
   		if(archiveName.right(4) == ".rar")
   		{
   		   Packer ="unrar";
   		   Parameter = "";
   		}
   		if(archiveName.right(4) == ".ace")
   		{
   		   Packer ="unace";
   		   Parameter = "";
   		}
//         debug(Packer);
         if(Packer.length() != 0)
   		{
      	   	
//      	   	debug("Fange an zu entpacken !");
      	   	KShellProcess proc;
   	      	proc << Packer;                           // welcher Packer wird benutzt ??
	   	      proc << Parameter;                        // eventuelle Parameter
   	   	   proc << tools::convertPfad(archiveName);  // der Linuxkonforme Dateiname
   	   	
   	   	   QApplication::connect(&proc, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
      	   	QApplication::connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
	      	   QApplication::connect(&proc, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
	      	   READY = false;
   		      proc.start(KProcess::Block,KProcess::All);
   		      while(!READY)
   		      {
   		         kapp->processEvents();
   		         kapp->processEvents();
   		         kapp->processEvents();
   		         kapp->processEvents();
   		      }
   		}
   		else
   		{
//   		   debug(archiveName + "\tUnbekanntes Archiveformat !");
   		}
      }
}
   // Zielverzeichnis neu einlesen
   KCommanderApp *m = (KCommanderApp *)main;
   m->readDir(zielLV->dirPath, zielLV);
   reject();
}

void dlgExtract::slotExamine()
{
   READY = true;
}
void dlgExtract::receivedStdout(KProcess *p, char *buffer, int bufSize)
{
   QString ausgabe = buffer;
   ausgabe = ausgabe.left(bufSize);
   ausgabe = "Stdout: " + ausgabe;
}
void dlgExtract::receivedStderr(KProcess *p, char *buffer, int bufSize)
{
   QString ausgabe = buffer;
   ausgabe = ausgabe.left(bufSize);
	QMessageBox::critical ( (QWidget *)this, "KTar", ausgabe, 0, 0 );
   READY = true;
}

