#include <kconfig.h>
#include <kapp.h>
#include "dlgfind.h"
	
bool isELF(QString file);	

dlgFind::dlgFind(QWidget *parent, const char *name ) : QDialog(parent,name,true)
{
	setGeometry(x()+10,y()+10,10,10);
	setMinimumSize(550,150);
	setMaximumSize(550,150);
	setCaption(i18n("Search files "));
	fertich = false;
	init();
}

void dlgFind::dirKeyPressed()
{
/***********************************************************************************
 Konfig Schreiben
***********************************************************************************/	
	QString s;
	KConfig *config;
	config = kapp->getConfig();
	config->setGroup("findDlg");
  int i;
			
	for(i=1;(i<c1->count()) && (i<30);i++)
	{
		s.sprintf("FindIn%d",i);
		config->writeEntry(s,c1->text(i));
	}
	for(i=1;(i<c2->count()) && (i<30);i++)
	{
		s.sprintf("FindWhat%d",i);
		config->writeEntry(s,c2->text(i));
	}
	for(i=1;(i<c3->count()) && (i<30);i++)
	{
		s.sprintf("FindName%d",i);
		config->writeEntry(s,c3->text(i));
	}
	
	if(c1->hasFocus()){c2->setFocus();}
	else if (c2->hasFocus()) {c3->setFocus();}
				else c1->setFocus();
}

void dlgFind::apply()
{	
	setCaption(i18n("Search files"));
	Pid = 0;
	
	dirKeyPressed();
	results2->clear();
	
	nameText= c3->currentText();
	dirText = c1->currentText();
	if (dirText.right(1)!= "/" && dirText.right(2) != NULL) dirText.append("/");
	fileText= c2->currentText();
		
	if (nameText != "")
	{
			nameFind();
			fertich = true;
	}
	 else
	{
	kapp->processEvents();
	
	KShellProcess proc("bash");
	proc.clearArguments();
	proc <<"find ";
	proc << dirText;
	proc << " -name ";
	proc << c2->currentText();
	proc << " >/tmp/ausgabe";

	QApplication::connect(&proc, SIGNAL(processExited(KProcess*)),this,SLOT(slotExamine()));
	proc.start(KProcess::Block,KProcess::All);
		
	while(!fertich)
	{
		kapp->processEvents();
		kapp->processEvents();
		kapp->processEvents();
	}
	
	dateiAuswert();	
  }
}

void dlgFind::nameFind()
{
	if (fileText != "" && fileText.right(1)!="*" && fileText.left(1)!="*")
	{
		if(isELF(dirText+fileText))
			{
				neu();
				setCaption(i18n("Is ELF file ==> no Search!"));
				return;
			}
		
		kapp->processEvents();
		kapp->processEvents();
		kapp->processEvents();
		
		KShellProcess proc("bash");
		proc.clearArguments();
		proc << "fgrep";
		proc << "-n";
		proc << nameText;
		proc << dirText+fileText;
		proc << ">/tmp/ausgabe";
		
		QApplication::connect(&proc, SIGNAL(processExited(KProcess*)),this,SLOT(slotExamine()));
		proc.start(KProcess::Block,KProcess::All);
		
		while(!fertich)
{
			kapp->processEvents();
			kapp->processEvents();
			kapp->processEvents();
}	
		dateiAuswert();	
		
		}
		
		else
		
		{
		
	  nameItem= "";
		kapp->processEvents();
		kapp->processEvents();
		kapp->processEvents();
	  results2->setGeometry(10,150,430,260);
		
		KShellProcess proc("bash");
		proc.clearArguments();
		proc <<"find";
		proc << dirText;
		if(fileText != "")
			{
			  proc << "-name";
			  proc << fileText;
			}
			else proc << "all";
		proc << ">/tmp/ausgabe";
 	
		QApplication::connect(&proc, SIGNAL(processExited(KProcess*)),this,SLOT(slotExamine()));
		proc.start(KProcess::Block,KProcess::All);
			
			while(!fertich)
			{
				kapp->processEvents();
				kapp->processEvents();
				kapp->processEvents();
			}
		
		char ausgew[512];
			QFile temp("/tmp/ausgabe");	
			if(temp.size()!=0)
			{		
			temp.open(IO_ReadOnly );
			
			while(!temp.atEnd())
				{					
					KShellProcess proc1("bash");
					fertich = false;
					kapp->processEvents();
					
					temp.readLine(ausgew,512);
		
					QString testFileName = ausgew;
					if(testFileName.find(" ") != -1)
					{
						convert(&testFileName);
					}
		      proc1.clearArguments();
		      proc1 << "fgrep";
		      proc1 << "-l";
		      proc1 << nameText;
		      proc1 << testFileName;
					QApplication::connect(&proc1, SIGNAL(processExited(KProcess*)),this,SLOT(slotExamine()));
					QApplication::connect(&proc1, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(neuElement(KProcess *, char *, int)));
					QApplication::connect(&proc1, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(grepError(KProcess *, char *, int)));
					proc1.start(KShellProcess::Block,KShellProcess::All);					
		
					while(!fertich)
					{
						kapp->processEvents();
						kapp->processEvents();
						kapp->processEvents();
					}
					
					if (nameItem != "")
						{
							results2->insertItem(nameItem);
							Pid++;
						}
					nameItem="";
		    }
			temp.close();
	    }
 	QString status;
 	status.sprintf(i18n("there are -> %d <- hits"),Pid);
	setCaption(status);
	resize(550,420);
  results2->show();

  temp.remove((const char*)"/tmp/ausgabe");
  }
}

void dlgFind::neu()
{
	Pid = 0;
	fertich = false;
	resize(550,150);
	results2->hide();
	c1->setEditText("");
	c2->setEditText("");
	c3->setEditText("");
	setCaption("Search files");
	return;
}

void dlgFind::panelize()
{
	accept();
}

void dlgFind::neuElement(KProcess *p,char *buffer,int bufflen)
{
	QString s = buffer;
	s = s.left(bufflen);
	if (s != nameItem)nameItem = s;
	kapp->processEvents();
	return;
}


dlgFind::~dlgFind()
{
}

void dlgFind::slotExamine()
{
	kapp->processEvents();
	fertich = true;
}

void dlgFind::resultExec(const char *s)
{
   QString a = s;
}

void dlgFind::dateiAuswert()
{
	  results2->setGeometry(10,150,430,260);
		char ausgew[512];
		QFile temp("/tmp/ausgabe");	
		if(temp.size()!=0)
			{		
			temp.open(IO_ReadOnly );
			
			while(!temp.atEnd())
				{
					kapp->processEvents();
					kapp->processEvents();
					kapp->processEvents();
					temp.readLine(ausgew,512);
					results2->insertItem(ausgew);
					Pid++;
		    }
			temp.close();
	    }
	  QString status;
	  status.sprintf(i18n("there are -> %d <- hits"),Pid);
	  setCaption(status);
		resize(550,420);
	  results2->show();

	  temp.remove((const char*)"/tmp/ausgabe");
}

void dlgFind::grepError(KProcess *p,char *buffer,int bufflen)
{
   p->kill(SIGTERM);
}

bool isELF(QString file)
{
	QFile testFile(file);
	if(!testFile.exists()) return false;
	QString head;
	char header[4];
	testFile.open(IO_ReadOnly);
	testFile.readBlock(header,4);
	testFile.close();
	head = header;
	if(head.right(3)=="ELF") return true;
		else return false;
}

void	dlgFind::convert(QString * kette)
{ //vor jedes " " ein "\" hngen
	int p=0;
	for(int i=0;i<(signed)strlen(*kette);i++)
	{
		if(kette->mid(p,1) == " ")
			kette->insert(p++,"\\");
		p++;
	}
}

void dlgFind::init()
{	

	l1 = new QLabel(i18n("Search in :"),this);
  l1->setAlignment( AlignRight );
  l1->setGeometry(10,50,160,20);
	
	l2 = new QLabel(i18n("Search for :"),this);
  l2->setAlignment( AlignRight );
  l2->setGeometry(10,80,160,20);
	
	l3 = new QLabel(i18n("Search content :"),this);
  l3->setAlignment( AlignRight );
  l3->setGeometry(10,110,160,20);
	
	c1 = new QComboBox(true,this);
  c1->setGeometry(210,50,320,20);
	c1->setFocus();
	connect(c1,SIGNAL(activated(const char *)),this,SLOT(dirKeyPressed()));
	
	c2 = new QComboBox(true,this);
  c2->setGeometry(210,80,320,20);
	connect(c2,SIGNAL(activated(const char *)),this,SLOT(dirKeyPressed()));
	
	c3 = new QComboBox(true,this);
  c3->setGeometry(210,110,320,20);
	connect(c3,SIGNAL(activated(const char *)),this,SLOT(dirKeyPressed()));
	
	QString b;
	for(int i=0;i<=2;i++)
	{
		b.sprintf("bt%d",i);
		btLeiste[i] = new QPushButton("",this,b);
		btLeiste[i]->setStyle(WindowsStyle);
	}
	btLeiste[0]->setText(i18n("&Find"));
	btLeiste[1]->setText(i18n("&New"));
	btLeiste[2]->setText(i18n("&Quit"));
	
	btLeiste[0]->setGeometry(20,10,160,20);
	btLeiste[1]->setGeometry(200,10,160,20);
	btLeiste[2]->setGeometry(380,10,160,20);

	connect(btLeiste[0],SIGNAL(clicked()),this,SLOT(apply()));
	connect(btLeiste[1],SIGNAL(clicked()),this,SLOT(neu()));
	connect(btLeiste[2],SIGNAL(clicked()),this,SLOT(panelize()));
	
//**************************************************************+
// Konfigs laden !!!
//**************************************************************"		
	
	QString s;
	KConfig *config;
	config = kapp->getConfig();
	config->setGroup("findDlg");
	
	c1->clear();
	for(int i=1;i<30;i++)
	{
    s.sprintf("FindIn%d",i);
    s = config->readEntry(s,"");
    if(s == "") break;
    c1->insertItem(s);
	}
	c1->setEditText(" ");
	
	c2->clear();
	for(int i=1;i<30;i++)
	{
    s.sprintf("FindWhat%d",i);
    s = config->readEntry(s,"");
    if(s == "")break;
    c2->insertItem(s);
	}
	c2->setEditText("");
	
	c3->clear();
	for(int i=1;i<30;i++)
	{
    s.sprintf("FindName%d",i);
    s = config->readEntry(s,"");
    if(s == "") break;
    c3->insertItem(s);
	}
	c3->setEditText("");


//***************************************************************	
	results2 = new QListBox(this,"show");
	connect(results2,SIGNAL(selected(const char *)),this,SLOT(resultExec(const char*)));
	results2->hide();
}
