#ifndef DLGFIND_H
#define DLGFIND_H

#include <qwidget.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include <qlistbox.h>
#include <kprocess.h>

/**Finden von Dateien oder Zeichenketten
in Dateien
  *@author Black_Bird
  */

class dlgFind : public QDialog  {
   Q_OBJECT
public:
	dlgFind(QWidget *parent=0, const char *name=0);
	~dlgFind();
	void init();
	QStrList *stack;
	QLabel *l1,*l2,*l3;
	QComboBox *c1,*c2,*c3;
	QPushButton *btLeiste[2];
	QListBox *results2;
	QString dirText,fileText,nameText,nameItem;
	int Pid;
	bool fertich;

	void dateiAuswert();
	void convert(QString *);
private slots:
	void dirKeyPressed();
	void apply();
	void neu();
	void panelize();
	void nameFind();
	void neuElement(KProcess *, char *, int);
	void	slotExamine();
	void grepError(KProcess *, char *, int);
	void resultExec(const char *);
};

#endif

