#ifndef DLGMOVE_H
#define DLGMOVE_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qdir.h>
#include <qdialog.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qstrlist.h>
#include <qmessagebox.h>
#include <kprocess.h>

#include "progress.h"
#include "listview.h"
#include "kcommander.h"

class dlgMove :public QDialog {
   Q_OBJECT
public:
	dlgMove(void){};
	dlgMove(
				listView *,		// SourceListview, nicht LINKS !
			   listView *,		// DestListview
			   const char *,	// SourcePath
			   const char *,	// DestPath
			   QWidget *parent=0, const char *name=0);

	~dlgMove();
	void        init();
	void        delDir(QString ldir);
	void        initDialog();
	myProgress 	*ProgressBar_1;
	myProgress 	*ProgressBar_2;
	QLabel 		*movelabel_1;
	QLabel 		*movelabel_2;
	QPushButton *cancelBtn;
	listView		*Source,*Dest;
	KProcess		proc;
//	const char 	*SourcePath, *DestPath;
	QString     SourcePath, DestPath;
	bool			abbruch;
	bool			nextfile;
   char 			*memory[4096];
 	QStrList    stack;


private slots:
	void        timerEvent(QTimerEvent *t);	
	void        cancelPressed();
	void        slotExamine();
private:
   QWidget     *main;
};

#endif




