#ifndef DLGOPTIONS_H
#define DLGOPTIONS_H

#include <qwidget.h>
#include <qtabdialog.h>
#include <qmultilinedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <qslider.h>
#include <qlayout.h>
#include <stdio.h>
#include <qstring.h>
#include <kconfig.h>
#include <kcolorbtn.h>
#include <kfiledialog.h>
#include <qcheckbox.h>
#include "kcommander.h"


class listView;
/**
  *@author Delta_X and Arno
  */

class dlgOptions : public QTabDialog  {
   Q_OBJECT
public: 
	dlgOptions(listView *lv1,listView *lv2,  QWidget *parent=0,int defaultPage=0, const char *name=0);
	~dlgOptions();
private:
	QWidget			*seite1,*seite2,*seite3,*seite4,*seite5,*seite6;
	int				gewaehlt;
	QRadioButton 	*b1,*b2,*b3,*b4,*b5;
	QButtonGroup	*bg,*bg2;
	KColorButton 	*cb1,*cb2,*cb3,*cb4,*cb5,*cb6,*cb7,*cb8,*cb9;
	QCheckBox		*cf,*cf1,*cf2,*cf3,*cf4,*cf5;
	KConfig 			*config;
	QTabDialog 		*tab;
	listView			*lv1,
						*lv2;
	QListBox			*shellList,
	               *mimeList,
	               *mimeProgList;
	QPushButton		*mimeButtonNew,
						*mimeButtonDelete,
						*mimeDirButton;

	QLineEdit		*leMimeProc,
	               *leShell;
	KFileDialog		*browseFile;
private slots:
	void				setup();
	void				apply();
	void 				selected ( const char *);
	void				filledClicked();
	void 				mimeNewClicked();
	void 				mimeDeleteClicked();
	void 				mimeDirClicked();
	void 				mimeTypeClicked(int);
	void				textChanged ( const char *s );
   void           shellChoosed(int);
   void           shellChanged( const char *shell );
};

#endif

