#ifndef DLGSHOW_H
#define DLGSHOW_H

#include <qwidget.h>
#include <qpainter.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qfileinfo.h>
#include <qstring.h>
#include <keditcl.h>

#include "listview.h"
#include "tools.h"

class ownShow : public QWidget  {
   Q_OBJECT
public:
	ownShow(QString ,QWidget *parent=0, const char *name=0);
	~ownShow();
	
	QImage 			image;
	QString 		filename;

protected:
	void initDialog();
	
private slots:
	void        paintEvent( QPaintEvent * );
};



class showWidget : public QWidget
{
  Q_OBJECT
public:
	showWidget(listView *,const char *, QWidget *parent=0, const char *name=0 );
	~showWidget();

	ownShow *neu;
protected:
//	KHTMLView		*htmView;
//	KHTMLWidget	*htmWidget;
	int 				id;
	void				init();
	listView 	  *Source;
	const char 	*SourcePath;
  bool				jpeg_image;

public :
  KEdit       *ked;
  QPopupMenu	*spopup;
  QString sou;
  QWidget      *hexWindow;
	
private slots :
  void 				resizeEvent(QResizeEvent *);
  void 				keyPressEvent(QKeyEvent *);
	void				mousePressEvent(QMouseEvent*);
  void 				menuPressed();
  void 				menuActivated(int);
  void 				weg();
  void 				htmlView();
  void 				picView();
  void            closed();
};

#endif
