//***************************************************************
// dlgsplit.h
//***************************************************************

#ifndef DLGSPLIT_H
#define DLGSPLIT_H

#include <qwidget.h>
#include <progress.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qslider.h>
#include <qpushbutton.h>

#include <qdialog.h>
#include "kcommander.h"

/**
  *@author delta_x
  */

class dlgSplit : public QDialog  {
   Q_OBJECT
public: 
	dlgSplit(QWidget *parent=0, const char *name=0);
	~dlgSplit();

protected: 
	QString SourcePath, DestPath;
	bool	process: true;
	void initDialog();
	myProgress *KProgress_1;
	
	QLabel *QLabel_1;
	QLabel *QLabel_2;
	QLabel *QLabel_3;
	QLabel *QLabel_4;
	QLabel *QLabel_5;
	QLabel *QLabel_6;
	
	QLabel		*QLineEdit_1;
	QLabel		*QLineEdit_4;
	
	QLineEdit *QLineEdit_3;
	QLineEdit *QLineEdit_2;
	
	QSlider *QSlider_1;
	
	QPushButton *QPushButton_1;
	QPushButton *CommandButton0;
	QPushButton *CommandButton1;

private slots:
	void sizeChanged(int);
	void bt0Clicked();
	void bt1Clicked();
	void mbChanged(const char *);
	void dirChanged(const char *);
};

#endif


