/***************************************************************************
                          inputbox.cpp  -  description
                             -------------------
    begin                : Sat Oct 9 1999
    copyright            : (C) 1999 by lcg
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "inputbox.h"
#include <kapp.h>



// wenn OK dann ergebnis 1 ansonsten 0




InputBox::InputBox( QWidget *parent, const char *xCaption,const char *Vorgabe=0, const char *name)
: QDialog( parent, name, TRUE )
{

	setGeometry(parent->x()+(parent->width()/2)-100, parent->y()+(parent->height()/2)-50,
					270,70);
						
	ok = new QPushButton( "&Ok", this );
	ok->setGeometry( 10,40, 90,25 );
	connect( ok, SIGNAL(clicked()), SLOT(accept()) );
	
	cancel = new QPushButton( i18n("&Cancel"), this );
	cancel->setGeometry( 170,40, 90,25 );
	connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

	me = new QLineEdit(this);
	if(Vorgabe != 0)
	{
		me->setText(Vorgabe);
		me->selectAll();
	}
	me->setGeometry(10,10,250,25);
	setCaption(xCaption);
	me->setFocus();
	
	connect(me,SIGNAL(returnPressed()),SLOT(accept()));
}

InputBox::~InputBox()
{
	delete cancel;
	delete ok;
	delete me;
	
}

