#include "kcommander.h"
#include "ktar.h"
#include "dlgfformat.h"

void KCommanderApp::insertParam(QString pa,KShellProcess *p)
{
	QString parameter;
	parameter.append(pa);
	// jetzt in temp nach den %-Params suchen

	if(parameter.find("^s") != -1)
	{
		int pos = parameter.find("^s");
		parameter.replace( pos, 2, listWithFocus->dirPath );
	}
	
	if(parameter.find("^d") != -1)
	{
		int pos = parameter.find("^d");
		if(listWithFocus == linkerListView)
			parameter.replace( pos, 2, rechterListView->dirPath );
		else
			parameter.replace( pos, 2, linkerListView->dirPath );
	}
	
	else if(parameter.find("^f") != -1)
	{
		int pos = parameter.find("^f");
		parameter.replace( pos, 2, *listWithFocus->lastItemClicked->text[0] );
	}
	else if(parameter.find("^F") != -1)
	{
		if(listWithFocus->itemsSelected() == 0) return;	// wenn keine files selectiert sind, ab zurck
		listItem *li = listWithFocus->Liste;
		while(li != 0)
		{
			if(li->selected)
			{
				parameter = listWithFocus->dirPath + *li->text[0];
				*p << parameter;
			}
			li = li->next;
		}		
		return;
	}

	*p << parameter;
};

void KCommanderApp::itemClicked(const char *,const char *)
{
}

void KCommanderApp::itemDoubleClicked(const char *s,const char *n)
{

   // which LV sent this event ?
   listView *l = linkerListView;
   if(strcmp("lv2",n) == 0)
      l = rechterListView;


// testen ob Klick auf ".."
	QString path = l->dirPath;       // get the current path
	if(strcmp(s,"..") == 0)          // clicked on DirUp ??
//****************************************************************************************			
//****************************************** wenn ".." geklickt **************************			
//****************************************************************************************			
	{
   	QString exDir;                         // damit der Cursor auf dem richtigen Item beim DirUp steht,
	                                          // mssen wir uns das aktuelle Dir merken
	   exDir = l->dirPath;
	   exDir = exDir.left(exDir.length()-1);  // SLASH abschneiden

	   // yes, now split on FTP,SMB or normal DIR
	   if(path.left(4) == "FTP:")
	   {
	      debug("FTP Dir up not available");
	      return;
	   }
	   if(path.left(2) == "//")
	   {
	      // SMB Dir up
	      if(path == "//")
	      {
	         readDir("/",l);
	         return;
	      }
	      if(countChars(path,'/') == 3)
	      {
	         // make a Backup of the Server where we are
	         QString server(path);
	         server = server.right(server.length()-2);   // cut the SLASHES on start of the string
	         server = server.left(server.length()-1);     // cut the SLASH on end
	         readDir("//",l);
	         listItem *li = l->Liste;
	         while( *li->text[0] != server)
	            li = li->next;
	         l->setItemFocus(li);
	
	      }
	      else
   	   {
	         QString oldPath(path);
	         oldPath = oldPath.right(oldPath.length()-2);   // cut the SLASHES on start of the string
	         oldPath = oldPath.left(oldPath.length()-1);     // cut the SLASH on end
       		while(oldPath.find("/") != -1)
       		{
       		   int p = oldPath.find("/");
       		   oldPath = oldPath.right(oldPath.length()-p-1);
       		}
	            	
   	      QString newPath = upDir(path);
   	      readDir(newPath,l);
   	
   			listItem *li = l->Liste;
   			while(li != 0)
   			{
   				if(oldPath == *li->text[0])
   				{
   					l->setItemFocus(li);
   					break;
   				}
   				li = li->next;
   			}
   	
   	   }
	      return;
	   }
   	// here we can be through that it is a normal dir
   	

   	// merken, in welchem verzeichnis wir waren
		// von vorn alles abschneiden bis zum letzten SLASH
		while(exDir.find("/") != -1)
		{
		   int p = exDir.find("/");
		   exDir = exDir.right(exDir.length()-p-1);
		}
   	
   	path = path.left(path.length()-1);	// cut the last SLASH
      if(path == "")                      // if the current string is "" than we on rootdir and can leave this function !!
      {
         return;
      }
      // ok, here we do a cdUp();
      QDir d;
      d.setPath(path);
      d.cdUp();
      readDir(d.path(),l);

      // now set the last visited Dir as focused Item
      if(strcmp("lv1",n) == 0)
		{
			// jetzt die Liste durchforsten nach dem eintrag exDir
			listItem *li = linkerListView->Liste;
			while(li != 0)
			{
				if(exDir == *li->text[0])
				{
					linkerListView->setItemFocus(li);
					break;
				}
				li = li->next;
			}
		}
		else
		{
			// jetzt die Liste durchforsten nach dem eintrag exDir
			listItem *li = rechterListView->Liste;
			while(li != 0)
			{
				if(exDir == *li->text[0])
				{
					rechterListView->setItemFocus(li);
					break;
				}
				li = li->next;
			}
		}
      return;
	}
//****************************************************************************************			
//****************************************** wenn DIR oder FILE geklickt *****************			
//****************************************************************************************			
   else
   {
	   if(path.left(4) == "FTP:")
	   {
	      debug("FTP Dir not available");
	      return;
	   }
	
//****************************************************************************************			
	   // is it an networkpath ??
	   if(path.left(2) == "//")
	   {
  				
			QString ss(s);
    		QDir d = QDir(netPathToRealPath(l->dirPath) + ss);
    		bool a = d.cd(netPathToRealPath(l->dirPath) + ss);
       	
  			if(path == "//")
  			{
  				if(l == linkerListView)
  				   readDir(l->dirPath + ss,linkerListView);
  				else
  				   readDir(l->dirPath + ss,rechterListView);
  				return;
  			}
			if(countChars(l->dirPath,'/') == 3)       	
  			{
  				if(l == linkerListView)
  				   readDir(l->dirPath + ss,linkerListView);
  				else
  				   readDir(l->dirPath + ss,rechterListView);
  				return;
  			}
       	
       	if(a)
         {
  				if(l == linkerListView)
  				   readDir(l->dirPath + ss,linkerListView);
  				else
  				   readDir(l->dirPath + ss,rechterListView);
  	      }
  	      else
  	      {
  	         // must be a file !!
  	         debug("Execute file on network");
  	      }
	      return;
	   }
	
//****************************************************************************************			
      // if it is an dir, goto one dir (s) deeper
      QString ss(s);
  		
  		QDir d = QDir(netPathToRealPath(l->dirPath) + ss);
  		bool a = d.cd(netPathToRealPath(l->dirPath) + ss);
     	if(a)
      {
//****************************************************************************************			
//****************************************** DIR geklickt ********************************			
//****************************************************************************************			
  				if(!d.isReadable())
  				{
  						QMessageBox::warning( this, i18n("System Message"),i18n("Permission Denied") );
  						return;
  				}
  				// hier auf links oder rechts splitten !
  				if(l == linkerListView)
  				{
  				   readDir(l->dirPath + ss,linkerListView);
  				}
  				else
  				{
  				   readDir(l->dirPath + ss,rechterListView);
  				}
  		}
  		else
  		{
//****************************************************************************************			
//****************************************** FILE geklickt *******************************			
//****************************************************************************************			
// Hier haut Arno mal was rein !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1

			QFile *file = new QFile();
			file->setName(netPathToRealPath(l->dirPath) + ss);
			QString extens = file->name();			
			QString extens2 = file->name();			
// Erstmal extension filtern
// da es unter Linux filenames mit mehr als zwei .en gibt muss ich anders testen !!!!!
			while(extens.find('.') != -1)
			{
				extens = extens.right(extens.length() - extens.find('.') - 1);
			}
// war die endung GZ dann testen ob auch noch geTARt wurde hehe :)			
			if(extens == "gz")
			{
				if(extens2.right(6) == "tar.gz")
					extens = extens2.right(6);			
			} 			
// jetzt habe ich die richtige Fileextension raus gefunden !!!!!!!!!!!!!!1

//			debug(extens);
//			KProcess proc;
			
// ende der testroutine fr gepackte files/////////////////////////////////////////////////////////////////
 			// if doubleclick on an KC-Splitfile
 			
 			if(path.right(4) == ".kcs")
 			{
 				dlgKCSinfo *d = new dlgKCSinfo(path,this);
 				d->setCaption(i18n("Splitfile Info"));
 				d->exec();
 				delete d;
 				return;
 			}
 			
 			// if KC doesn't know the filetype
			QString mime = optionen::getMimeType(netPathToRealPath(l->dirPath) + ss);
			mimeExec(netPathToRealPath(l->dirPath) + ss);
  		}
   }
	

}

//******************************************************************************************
void KCommanderApp::mimeExec(const char *t)
{
	// wenn es ausfhrbar ist, dann starten
	QFileInfo fi(t);		
	int p = optionen::getFilePermission(t);
	// hat das File irgendein ExeFlag ??
	if((p & 0100) || (p & 0010) || (p & 0001))
	{	// ja, dann ausfhren
		exec(t);		// keine Endung dranne, dann normal starten ber xterm
		return;
	}
	
	
	QString mime = optionen::getMimeType(t);		// Endung rausfiltern
	if(mime == "")
	{
		//ohne endung auch keine verknuepfung !
		return;
	}
	QString proggy = optionen::getMimeProg(mime);
	if(proggy == "")
	{
//		exec(t);
		return;
	}
	else
	{
		KProcess proc;
		proc << "xterm" << "-e" << proggy << t;
		proc.start(KProcess::DontCare,KProcess::All);
	}
}

//******************************************************************************************
void KCommanderApp::fillDriveAssigns(QPopupMenu *menu)
{
	KConfig *config = kapp->getConfig();
	config->setGroup("Assignments");
	QString s;
	QString titel;
	QString titel2;
	for(int i=0; i<26;i++)
	{
		s.sprintf("DriveAssign%c",i+'A');
		titel = config->readEntry(s,"");
		titel2.sprintf("&%c - ",i+'A');
		titel = titel2 + titel;
		menu->insertItem(titel);
	}
}
//******************************************************************************************
void KCommanderApp::LVkeyPressed(const char *s)
{
	itemSelected();
	QString code;
	code = s;
	
	if((code.length() == 2) && (code.left(1) == "S"))
	{
      if( (code.mid(1,1) >= "A") && (code.mid(1,1) <= "Z"))
      {
   	   code = code.right(1);
   	   bool end = false;
   	   listItem *temp = listWithFocus->lastItemClicked;   //points to the actuell selected item
   	   // get next item in list
m1:
   	   kapp->processEvents();
   	   temp = temp->next;
   	   // check if end of list
   	   if(!temp)
   	   {
   	      // if end-flag is true, we leave this function
   	      if(end)
   	         return;
   	      end = true; // set the end-flag, we dont want a endless loop !
   	      // if it was the end of list, we start at the beginning with search
   	      temp = listWithFocus->Liste;
   	      kapp->processEvents();
   	   }
   	   // now we have the 'NEXT' item and check for the letter
   	   QString letter = *temp->text[0];
   	   letter = letter.left(1);
   	   letter = letter.upper();
   	   if(code == letter)
   	   {
   	      listWithFocus->setItemFocus(temp);
   	      return;
   	   }
   	   goto m1;
	   }
	}
	//***************************************************************************************
	if(strcmp(s,"^U") == 0)
	{
	   menuActivated(ID_MENU_SWAPLISTVIEWS);
      return;
   }	
	//***************************************************************************************
	if(strcmp(s,"S!") == 0)
	{
	   menuActivated(ID_MENU_SHOW_DIRS);
      return;
   }	
	//***************************************************************************************
	if(strcmp(s,"S\"") == 0)
	{
	   menuActivated(ID_MENU_SHOW_FILES);
      return;
   }	
	//***************************************************************************************
	if(strcmp(s,"S") == 0)
	{
	   menuActivated(ID_MENU_SHOW_HIDDEN);
      return;
   }	
	//***************************************************************************************
	if(strcmp(s,"S$") == 0)
	{
	   menuActivated(ID_MENU_SHOW_SYSTEMFILES);
      return;
   }	
	//***************************************************************************************
	// compare with Assigned Drives
	if(strcmp(s,"SF1") == 0)
	{
      linkerListView->shiftItem = 0;
      QPopupMenu * popup = new QPopupMenu(0,"1");
      fillDriveAssigns(popup);
      connect(popup,SIGNAL(activated(int)),this,SLOT(drivePopupActivated ( int )));
      popup->popup(QPoint(x()+linkerListView->x()+30,y()+linkerListView->y()+30));
	   return;
	}
//******************************************************************************************
	if(strcmp(s,"SF2") == 0)
	{
      rechterListView->shiftItem = 0;
      QPopupMenu * popup = new QPopupMenu(0,"2");
      fillDriveAssigns(popup);
      connect(popup,SIGNAL(activated(int)),this,SLOT(drivePopupActivated ( int )));
      popup->popup(QPoint(x()+rechterListView->x()+30,y()+rechterListView->y()+30));
	   return;
	}
//******************************************************************************************
	
	if(strcmp(s,"^R") == 0)
	{
		menuActivated(ID_MENU_QUELLE);
	}
//******************************************************************************************
	if(strcmp(s,"ENTF") == 0)
	{
		LVkeyPressed("F8");
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"EINFG") == 0)
	{
		itemSelected();
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"+") == 0)
	{
		menuActivated(ID_MENU_MARKGROUP);
		itemSelected();
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"-") == 0)
	{
		menuActivated(ID_MENU_REMARKGROUP);
		itemSelected();
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"F5") == 0)      // Packen aktivieren
	{
		menuActivated(ID_MENU_PACK);
		itemSelected();
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"F9") == 0)      // Entpacken aktivieren
	{
		menuActivated(ID_MENU_UNPACK);
		itemSelected();
		return;
	}
	//***************************************************************************************
	if(strcmp(s,"F2") == 0)
	{
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
			{
				sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
				destLV	= linkerListView;
			}
	
	  popup5->show();
		popup5->move(QPoint(x()+sourceLV->x()+10,y()+sourceLV->y()+50));	
			return;
	}
	//***************************************************************************************
	if(strcmp(s,"F3") == 0)
	{
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		
		const char 	*sp = netPathToRealPath(leftDirPath),
				  		*dp = netPathToRealPath(rightDirPath);
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
			{
				sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
				destLV	= linkerListView;
				dp = netPathToRealPath(leftDirPath);
				sp = netPathToRealPath(rightDirPath);
			}
			showWidget *d = new showWidget(sourceLV,sp);
			
			d->show();

			return;
	}
	//***************************************************************************************
	if(strcmp(s,"F4") == 0)
	{
   	int size;
		KProcess proc;
				
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		const char 	*sp = netPathToRealPath(leftDirPath),
					  	*dp = netPathToRealPath(rightDirPath);
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
		{
			sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
			destLV	= linkerListView;
			dp = netPathToRealPath(leftDirPath),
			sp = netPathToRealPath(rightDirPath);
		}

      QString sou;
      	
    	struct listItem *s = sourceLV->Liste;  // also hier erstemal Zeiger auf Sourceliste holen
	   while(s != 0)
	   {
    		if (s->hasFocus) break;
        	else s = s->next;
      }
 			
 		sou = sp + *s->text[0];	
		s = 0;
      QFileInfo gr(sou);
		size = gr.size();
		if(!gr.isDir())
		{
			proc << "kedit" << sou;
			QApplication::connect(&proc, SIGNAL(processExited(KProcess *)), this, SLOT(slotExamine(KProcess *)));
			proc.start(KProcess::DontCare,KProcess::All);
      }
		return;	
	}
//***************************************************************************************
	if(strcmp(s,"SF4") == 0)
	{
		QString name;
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		const char *sp = netPathToRealPath(leftDirPath),
			         *dp = netPathToRealPath(rightDirPath);
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
		{
			sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
			destLV	= linkerListView;
			dp = netPathToRealPath(leftDirPath),
			sp = netPathToRealPath(rightDirPath);
		}
  		InputBox ip(this,i18n("Name Of The New File"));
  		int code =  ip.exec();
		
    	if(code != 0)
    	{
			KProcess proc;
			name = sp;
			proc << "kedit"<< name+ip.me->text();
			QApplication::connect(&proc, SIGNAL(processExited(KProcess *)), this, SLOT(slotExamine(KProcess *)));
			proc.start(KProcess::DontCare,KProcess::All);
		}
		return;
	}
	//***************************************************************************************
	// Beispiel fr Dialog ....
	if(strcmp(s,"F5") == 0)
	{
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		
		QString ldp = leftDirPath;
		QString rdp = rightDirPath;

		const char 	*sp = ldp,
					  	*dp = rdp;
		
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
			{
				sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
				destLV	= linkerListView;
				dp = ldp,
				sp = rdp;
			}
			bool p = true;
			if(sourceLV->itemsSelected() == 0)
				if(sourceLV->lastItemClicked == sourceLV->Liste)
					p = false;
			// nur wenn p TRUE ist, dialog ausfhren
			if(p)
			{
				dlgCopy2 *d = new dlgCopy2(
													sourceLV,
													destLV,
													sp,
													dp,
													(QWidget *)this);
				d->setCaption(i18n("Copy Files"));
				d->exec();
				delete d;
			   listItem *li = sourceLV->Liste;
			   while(li)
			   {
			      li->selected = false;
			      li = li->next;
			   }
			}
		return;
	}
//***************************************************************************************
	if(strcmp(s,"F6") == 0)
	{
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;
		QString ldp = netPathToRealPath(leftDirPath);
		QString rdp = netPathToRealPath(rightDirPath);

		const char *sp = ldp,
					  *dp = rdp;
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
			{
				sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
				destLV	= linkerListView;
				dp = ldp,
				sp = rdp;
			}
      if(sourceLV->itemCount < 2)
         return;
      if(sourceLV->itemsSelected() == 0)
         if(sourceLV->lastItemClicked == sourceLV->Liste)
            return;

		// nun abfragen, ob files selectiert wurden
			dlgMove *d = new dlgMove(sourceLV,
												destLV,
												sp,
												dp,
												(QWidget *)this);
			d->setCaption(i18n("Move Files"));
			d->show();
			delete d;
			return;
}
//***************************************************************************************
	if(strcmp(s,"F7") == 0)
	{
		QString newDir;
		
			QString n;
			if(!rechterListView->listHasFocus)
			{
	    		InputBox ip(this,i18n("Name Of The New Directory ?"));
   	 		int code =  ip.exec();
    			newDir = ip.me->text();
				n = netPathToRealPath(leftDirPath) + newDir;
				QDir neue;
      	  	if (code) neue.mkdir(n);
					readDir(leftDirPath,linkerListView);
			}
			else
			{
	    		InputBox ip(this,i18n("Name Of The New Directory ?"));
   	 		int code =  ip.exec();
    			newDir = ip.me->text();
				n = netPathToRealPath(rightDirPath) + newDir;
	        	QDir neue;
   	     	if(code) neue.mkdir(n);
					readDir(rightDirPath,rechterListView);
			}
			itemSelected();
			return;
	}
//***************************************************************************************
	if(strcmp(s,"F8") == 0)
	{
		listView *sourceLV = linkerListView;
		listView *destLV 	 = rechterListView;

		QString ldp = leftDirPath;
		QString rdp = rightDirPath;
		
		const char *sp = ldp,
					  *dp = rdp;
		
		// Quellfenster ist immer das mit dem Focus
		if(rechterListView->listHasFocus)
			{
				sourceLV = rechterListView;	// raussuchen und in sourceLV speichern
				destLV	= linkerListView;
				dp = ldp,
				sp = rdp;
			}
		   	if(QString(*sourceLV->lastItemClicked->text[0])=="..")
   	  return;
		
		dlgDel *d = new dlgDel(sourceLV,
											destLV,
											sp,
											dp,
											(QWidget *)this);
		d->setCaption(i18n("Delete Files"));
		d->show();
		delete d;
		itemSelected();
		return;
	}
//***************************************************************************************
//	wenn SPACE auf einem Directory gedrckt wurde, die Size recursive auslesen
//***************************************************************************************
	if(strcmp(s," ") == 0)
	{
		listView *lv = linkerListView ;					// lv jetzt temporr
		listItem *li;                 // li auch
		QString s = netPathToRealPath(leftDirPath);			// s zeiger auf path von listview
		if(rechterListView->listHasFocus)					// wenn der 2te listview den focus hat,
		{
			lv = rechterListView;										// variablen verbiegen
			s = netPathToRealPath(rightDirPath);
		}
		li = lv->getItemFocus();									// item mit focus holen
		if(li->listviewIcon ==  foldericon)		// ist item ein dir ??
		{
			unsigned int sz;												// ja! Size auslesen
			sz = getDirSize( (const char *)s + *li->text[0] + "/");
			QString t;
			t.sprintf("%u",sz);
			*li->text[1] = t;
		}
		lv->refreshOneLine(li);
		itemSelected();
		return;
	}		
//***************************************************************************************
	if(strcmp(s,"F9") == 0)
	{
			menuActivated(ID_MENU_HELPTHIS);
			return;
	}
//	debug("Tastencode: " + (QString )s);
}
//***************************************************************************************
//             MENUABFRAGE
//***************************************************************************************
void setSortButton(listView *lv,int b)
{
   // if the new sortbutton is the same as allready selected,
   // change the sortorder
   if(lv->sortButton == b)
   {
      if(lv->sortOrder)
         lv->sortOrder = false;
      else
         lv->sortOrder = true;
   }
   else
   {
   }
   lv->sortButton = b;
   lv->refreshColums(0);
   lv->sortList();
   lv->refreshListview();
};

void KCommanderApp::menuActivated(int itemId)
{
  listItem *li = listWithFocus->Liste;
  QString dest;
  if(listWithFocus == rechterListView)
  	dest = netPathToRealPath(leftDirPath);
  else
  	dest = netPathToRealPath(rightDirPath);
  QDir d;
  int code;
		
	
	
	switch (itemId)
	{
		case 2:
					break;

      case ID_MENU_SORT_NAME:
               {
                  setSortButton(listWithFocus,0);
                  break;
               }
      case ID_MENU_SORT_SIZE:
               {
                  setSortButton(listWithFocus,1);
                  break;
               }
      case ID_MENU_SORT_DATE:
               {
                  setSortButton(listWithFocus,2);
                  break;
               }
      case ID_MENU_SORT_PERM:
               {
                  setSortButton(listWithFocus,3);
                  break;
               }
      case ID_MENU_DRIVESPACE:
               {
                  int x;
                  if(driveSpace)
                  {
                     // close DS-Window
                     delete driveSpace;
                     driveSpace = 0;
                    	linkerListView  ->setFocusPolicy(StrongFocus);
                    	rechterListView ->setFocusPolicy(StrongFocus);
                  }
                  else
                  {
                     // open new driveSpaceWindow
                     driveSpace = new wdgDriveSpace(listWithFocus,this);
                     if(listWithFocus == linkerListView)
                     {
                        x = rechterListView->x();
                       	rechterListView ->setFocusPolicy(NoFocus);
                     }
                     else
                     {
                        x = linkerListView->x();
                       	linkerListView ->setFocusPolicy(NoFocus);
                     }
                     driveSpace->setGeometry(x,listWithFocus->y(),listWithFocus->width(),listWithFocus->height());
                     driveSpace->show();
                  }
                  return;
                  break;
               }
      case ID_MENU_NETWORK:
               {
                  // Hier passiert nichts, ausser alle Rechner im Netzwerk anzeigen
                  // zuerst aktiven Listview suchen
                  listView *lv = listWithFocus;
//                  lv->list_service = SERVICE_NETWORK;
                  if(lv == linkerListView)
                  {
                     leftDirButton->setText(i18n("Network"));
							leftSelLabel->hide();
                  }
                  else
                  {
                     rightDirButton->setText(i18n("Network"));
							rightSelLabel->hide();
                  }
						lv->clear();
                  readDir("//",lv);     // wenn SERVICE = NETWORK, dann heisst "" dass er alle Rechner
                                       // einlesen soll
                  break;
               }
//***************************************************************************************
		case ID_MENU_TREELIST:
					{
						// ist ein DirView offen ?
						if(dirListBox)
						{
							delete dirListBox;
							dirListBox = 0;
							if(linkerListView->isVisible())
							{
								rechterListView->show();
								rightSelLabel->show();
								rightDirButton->setText(rightDirPath);
							}
							else
							{
								linkerListView->show();
								leftSelLabel->show();
								leftDirButton->setText(leftDirPath);
							}
							return;
						}
						// OK, es ist keine DirListBox geffnet
						// zuerstmal die Position des dirViews ausrechnen
						listView *lv = listWithFocus;
						if(lv == linkerListView)
						{
								leftSelLabel->hide();
								leftDirButton->setText(i18n("Directory Tree"));
						}
						else
						{
								rightSelLabel->hide();
								rightDirButton->setText(i18n("Directory Tree"));
						}
						dirListBox = new dirview(listWithFocus,"/",this);
						dirListBox->setGeometry(lv->x(),lv->y(),lv->width(),lv->height());
						dirListBox->show();
						connect(dirListBox,SIGNAL(dirSelected(const char *)),this,SLOT(dirviewItemSelected(const char *)));
						lv->hide();
						return;
						break;
					}
//***************************************************************************************
		case ID_MENU_FORMAT:
					{
//					   dlgFFormat *floppy = new dlgFFormat;
//					   floppy->exec();
//					   if(floppy)
				      formatMan *fm = new formatMan();
				      fm->invoke();
				      delete fm;
					}
//***************************************************************************************
		case ID_MENU_SPLITFILE:
					{
						// nur aufrufen, wenn es sich um ein file handelt
						
						listView *lv = listWithFocus;
						QDir f(netPathToRealPath(lv->dirPath) + *lv->lastItemClicked->text[0]);
						if(!f.exists())
						{
							dlgSplit *ds = new dlgSplit(this);
							ds->exec();
							delete ds;
							if(linkerListView->dirPath == rechterListView->dirPath)
							{
								readDir(rightDirPath,rechterListView);
								readDir(leftDirPath,linkerListView);
							}
							else
							{
								if(listWithFocus == linkerListView)
									readDir(rightDirPath,rechterListView);
								else
									readDir(leftDirPath,linkerListView);
							}
						}
						
						return;
						break;
					}
//***************************************************************************************
		case ID_MENU_JOINFILE:
					{
						// nur aufrufen, wenn es sich um ein file handelt
						
						listView *lv = listWithFocus;
						QString p = netPathToRealPath(lv->dirPath);
						QDir f( p + *lv->lastItemClicked->text[0]);
						if(!f.exists())
						{
							QString fn( p + *lv->lastItemClicked->text[0]);
							if(fn.right(4) == ".kcs")
							{
								dlgJoin *ds = new dlgJoin(this);
								ds->exec();
								delete ds;
								if(linkerListView->dirPath == rechterListView->dirPath)
								{
									readDir(rightDirPath,rechterListView);
									readDir(leftDirPath,linkerListView);
								}
								else
								{
									if(listWithFocus == linkerListView)
										readDir(rightDirPath,rechterListView);
									else
										readDir(leftDirPath,linkerListView);
								}
							}
						}
						
						return;
						break;
					}
//***************************************************************************************
		case ID_MENU_SEARCHFILE:
					{
						dlgFind *df = new dlgFind(this);
						df->exec();
						delete df;
						return;
						break;
					}
//***************************************************************************************
		case ID_MENU_ASSIGNS:
					{
						dlgEditAssigns *df = new dlgEditAssigns(this);
						df->exec();
						delete df;
						return;
						break;
					}
//***************************************************************************************
		case ID_MENU_ATTRIBUTES:
					{
						listView *lv = listWithFocus;
						bool p = true;
						if(lv->itemsSelected() == 0)
							if(lv->lastItemClicked == lv->Liste)
								p = false;
						
						if(p == true)
						{
							dlgPermissions *dp = new dlgPermissions(listWithFocus);
							int result = dp->exec();
							delete dp;
							result = 0;
						}
						return;
						break;
					}
//					{
//***************************************************************************************
		case ID_MENU_UNPACK:	// Packen !
					{
       				QString zielpfad;
       				listView *sv = linkerListView,
       				         *lv = listWithFocus;
       				if(lv == linkerListView)
       				{
       				   zielpfad = netPathToRealPath(rightDirPath);
       				   sv = rechterListView;
       				}
       				else
       				{
       				   zielpfad = netPathToRealPath(leftDirPath);
       				   sv = linkerListView;
       				}
       				InputBox ip(this,i18n("Extract to ?"),zielpfad);
	   	    		if( ip.exec() == 0)
	   	    		   break;					// Abbruch !!
                  zielpfad = ip.me->text();
					   // zielpfad auf existenz testen
					   QDir ziel(zielpfad);
					   if(!ziel.exists())
   					{
	   					QMessageBox::warning( this, i18n("System Message"),i18n("Destination Dir does not exist !") );
   						return;
		   			}
						dlgExtract *de = new dlgExtract(lv,sv,ziel.path(),this);
						de->exec();
						delete de;
					   return;
						
						return;
					}
//***************************************************************************************
		case ID_MENU_BUTTONBAR:
					{
						dlgEditToolBar *de = new dlgEditToolBar(this);
						de->exec();
						delete de;
						updateToolbar();
					   return;
					}
//***************************************************************************************
		case ID_MENU_PACK:	// Packen !
					{
						listView *lv = listWithFocus;
						if(!lv->itemsSelected())	// wenn keine selektiert sind, dann
						{
							if(*lv->lastItemClicked->text[0] == "..")
								return;
						}
						QString s;
						bool internal = true;					
						
						int flag = optionen::askPack();
						if(flag == optionen::Ask)
						{
					      int frage = QMessageBox::warning( this, i18n("System"),
   																		i18n("Using Of Wich Packemode ?"),
            			                                   	i18n("&Intern"),
                  			                             	i18n("&Extern"),
                        			                       	i18n("&Cancel"),
                                                			0, 
                                                			2 );
          		if(frage == 2)
          			return;		// gar nicht packen !
          		if(frage == 1)
          			internal = false;
						}
						else
							if(flag == optionen::External)
								internal = false;
						
						//zuerst den Archivenamen abfragen
nochmal:
            QString aname;
            if(lv->itemsSelected())
				{
	            aname = commandLineLabel->text();	// Pathnamen als Basis fr
	            aname = aname.left(aname.length()-1);			// SLASH am Ende weg
	   		}
	         else
	         	aname = *lv->lastItemClicked->text[0];
            																					// Archivnamen whlen
						while(aname.find("/",0,false) != -1)			// vom Anfang alles bis incl. letztem Slash
						{																					// lschen
							int l = aname.find("/",0,false);
							aname = aname.right(aname.length()-l-1);
						}

						if(aname == "")                           // ist aname leer, auf "archive" setzen
							aname = "archieve";						
						// KTar muss jetzt noch bergeben werden, nach welchem Prinzip gepackt wird !
						aname = dest + aname ;                    // vor dem archive noch den path setzen
												
    				InputBox ip(this,i18n("Archievename ?"),aname);
		    		if( ip.exec() == 0) break;					// Abbruch !!
            aname = ip.me->text();
            if(aname == "") break;							//kein Name, also raus hier

// existiert Ziel schon ?
						QFile ff(QString(aname) + ".tar");
						if(ff.exists())
            {
             		int i = QMessageBox::information ( this, i18n("Destination exist !"), i18n("Overwrite ?"), QMessageBox::Yes, QMessageBox::No);
								if(i == QMessageBox::No)
									goto nochmal;
						}

						// jetzt rekuriv das verzeichnis auslesen und in tempdatei schreiben
						
						listItem *tempList = listWithFocus->Liste->next;
						
						QTime t = QTime::currentTime();
						s = t.toString();
						s.remove(2,1);
						s.remove(4,1);
						s = "/tmp/" + s;	// /tmp/ ist fr alle zum schrieben
						QFile *f = new QFile(s);
						// nur schreiben !
						if(f->open(IO_WriteOnly))
						{
							QString thisDir(QString(commandLineLabel->text()));
							QString temp(QString(thisDir + "\n"));
							f->writeBlock(temp,strlen(temp));
							
							// jetzt alle zu packenden files inclusive path in die datei schreiben
							if(lv->itemsSelected())	// wenn keine selektiert sind, dann
							{

								while(tempList != 0)
								{
										if(tempList->selected)
										{
											// wenns ein directory ist, dann writerecursiv aufrufen,
											// ansonsten filenamen schreiben
											QFileInfo fi(QString(thisDir + *tempList->text[0]));
											if(fi.isDir())
											{
												writeRecursiveList(f,thisDir + *tempList->text[0],strlen(thisDir));
											}
											else
											{
												QString a;
												a = *tempList->text[0];
												a += "\n";
												convert(&a);
												f->writeBlock(a,strlen(a));
											}
										}
										tempList = tempList->next;
								}
							}
							else	// hier nur das angeklickte raussuchen
							{
								tempList = lv->lastItemClicked;
								QFileInfo fi(QString(thisDir + *tempList->text[0]));
								if(fi.isDir())
								{
									writeRecursiveList(f,thisDir + *tempList->text[0],strlen(thisDir));
								}
								else
								{
									QString a;
									a = *tempList->text[0];
									a += "\n";
									convert(&a);
									f->writeBlock(a,strlen(a));
								}
							}
							
							f->close();
							if(!internal)
							{
								KProcess proc;
								proc << "ktar";
								proc << "kc";											//nur KCommander darf aufrufen !!
								proc << s;												// name des tempfiles
								proc << aname;										// Name des Archives
								proc << packMethode;							// erklrt sich von selbst
								proc.start(KProcess::DontCare,KProcess::All);
							}
							else
							{
									KTar *ktar = new KTar(s,aname,this);
									ktar->exec();
									delete ktar;
									if(listWithFocus == linkerListView)
										readDir(rightDirPath,rechterListView);
									else
										readDir(leftDirPath,linkerListView);
							}
						}
					}
					break;
//***************************************************************************************
		case ID_MENU_EXIT:
					saveOptions();
					close(this);
					break;
//***************************************************************************************
		case ID_MENU_MARKGROUP:															// Auswahl an files
	   		{
	   		InputBox *ip = new InputBox(this,i18n("Fileextension"));
    		code =  ip->exec();
				d.setNameFilter(ip->me->text());
				if(code != 0)
				{
					// zuerst ein DIR holen
					if(listWithFocus == linkerListView)
						d = netPathToRealPath(leftDirPath);
					else
						d = netPathToRealPath(rightDirPath);
						d.setFilter(QDir::Files | QDir::Dirs | QDir::Hidden);
					for ( int i=0; i<(signed)d.count(); i++ )
						{
								// alle items->text die d[i] gleichen, auf selected stellen
							  li = listWithFocus->Liste->next;
								while(li != 0)
								{
									if(strcmp(*li->text[0],d[i]) == 0)
										li->selected = true;
									li = li->next;
								}
						}
				listWithFocus->refreshListview();
				}
				break;		
				}
//***************************************************************************************
		case ID_MENU_REMARKGROUP:															// Auswahl an files
	   		{
	   		InputBox *ip = new InputBox(this,i18n("Fileextension"));
    		code =  ip->exec();
				d.setNameFilter(ip->me->text());
				if(code != 0)
				{
					// zuerst ein DIR holen
					if(listWithFocus == linkerListView)
						d = netPathToRealPath(leftDirPath);
					else
						d = netPathToRealPath(rightDirPath);
						d.setFilter(QDir::Files | QDir::Dirs | QDir::Hidden);
					for ( int i=0; i<(signed)d.count(); i++ )
						{
								// alle items->text die d[i] gleichen, auf selected stellen
							  li = listWithFocus->Liste->next;
								while(li != 0)
								{
									if(strcmp(*li->text[0],d[i]) == 0)
										li->selected = false;
									li = li->next;
								}
						}
				listWithFocus->refreshListview();
				}
				break;		
				}
//***************************************************************************************
		case ID_MENU_MARKALL:															// Alle Dateien auswhlen
					while(li != 0)
					{
						li->selected = true;
						li = li->next;
					}
					listWithFocus->refreshListview();
					itemSelected();
					break;
//***************************************************************************************
		case ID_MENU_MARKNONE:															// keine Dateien auswhlen
					while(li != 0)
					{
						li->selected = false;
						li = li->next;
					}
					listWithFocus->refreshListview();
					itemSelected();
					break;
//***************************************************************************************
		case ID_MENU_MARKREVERSE:															// Auswahl umkehren
					while(li != 0)
					{
						if(li->selected)
							li->selected = false;
						else
							li->selected = true;

						li = li->next;
					}
					listWithFocus->refreshListview();
					itemSelected();
					break;
//***************************************************************************************
		case ID_MENU_STARTTERM:				// Terminal starten
					{
               	KConfig *config;
               	config = kapp->getConfig();
               	config->setGroup("UserShell");
                  QString shell = config->readEntry("shell","/usr/bin/csh");
						if(shell.right(1) == "\n")
						   shell = shell.left(shell.length()-1);
						QDir::setCurrent(commandLineLabel->text());	
						KProcess proc;
						proc << "xterm";
						proc << "-e";
						proc << shell;
						proc.start(KProcess::DontCare,KProcess::All);
						break;
					
					}
//***************************************************************************************
		case ID_MENU_SWAPLISTVIEWS:		// Fenster tauschen
					{
						// first take the items with focus and his names
						QString l = *linkerListView->lastItemClicked->text[0];
						QString r = *rechterListView->lastItemClicked->text[0];
						QString lpath = linkerListView->dirPath;
						QString rpath = rechterListView->dirPath;
						int lfilter = linkerListView->dirFilter;
						int rfilter = rechterListView->dirFilter;
						linkerListView->dirFilter = rfilter;
						rechterListView->dirFilter = lfilter;
						readDir(rpath,linkerListView);
						readDir(lpath,rechterListView);
						if(listWithFocus == linkerListView)
						{
						   rechterListView->setFocus();
						   linkerListView->clearFocus();
						}
						else
						{
						   linkerListView->setFocus();
						   rechterListView->clearFocus();
						}
						// search booth lists for the lastClickedItem
						listItem *li = linkerListView->Liste;
						listItem *ri = rechterListView->Liste;
						
						while(*li->text[0] != r)
						   li = li->next;
						while(*ri->text[0] != l)
						   ri = ri->next;
						linkerListView->setItemFocus(li);
						rechterListView->setItemFocus(ri);
						break;
					}
//***************************************************************************************
		case ID_MENU_OPTIONS:
					{
						dlgOptions *d = new dlgOptions(	linkerListView,
																	rechterListView,
																	this);
						int a = d->exec();
						delete d;
						if(a)
							saveOptions();
//						readOptions();
						break;
					}
//***************************************************************************************
		case ID_MENU_HELPABOUT:
					{
						aboutwindow *d = new aboutwindow(this);
						d->exec();
						delete d;
						break;
					}
//***************************************************************************************
		case ID_MENU_SYSINFO:
					{
						dlgSysInfo *d = new dlgSysInfo(this);
						d->exec();
						delete d;
						break;
					}
//***************************************************************************************
		case ID_MENU_STARTER:
					{
						dlgStartmenu *d = new dlgStartmenu(this);
						d->exec();
						delete d;
						// Alle Mens von ID_STARTMENU bis ID_STARTMENU+99 lschen
						for(int i=ID_STARTMENU;i< ID_STARTMENU+100;i++)
							if(popup5->findItem(i))
								popup5->removeItem(i);
						// jetzt die vorhandenen neuen adden !
						KConfig *config = kapp->getConfig();
						config->setGroup("Startmenu");
						QString s;
						bool flag = true;
						int i=0;
						while(flag)
						{
							s.sprintf("Menutitle%d",i);
							QString titel = config->readEntry(s,"");
							if(titel == "") break;
							popup5->insertItem(titel,ID_STARTMENU+i);
							i++;
						}
						
						break;
					}
//***************************************************************************************
		case ID_MENU_QUELLE:
					{
						if(linkerListView->listHasFocus)
							readDir(leftDirPath,linkerListView);
						else
							readDir(rightDirPath,rechterListView);
						itemSelected();
						break;
					}

		    		
//***************************************************************************************
		case ID_MENU_HELPTHIS:
					{
//						emit buttonLeiste[6]->clicked();
						break;
					}
//***************************************************************************************
      case ID_MENU_SHOW_DIRS:
               {
                  popup3->setItemChecked(ID_MENU_SHOW_DIRS,!popup3->isItemChecked(ID_MENU_SHOW_DIRS));
                  updateFilterFromMenu();
                  break;
               }
//***************************************************************************************
      case ID_MENU_SHOW_FILES:
               {
                  popup3->setItemChecked(ID_MENU_SHOW_FILES,!popup3->isItemChecked(ID_MENU_SHOW_FILES));
                  updateFilterFromMenu();
                  break;
               }
//***************************************************************************************
      case ID_MENU_SHOW_HIDDEN:
               {
                  popup3->setItemChecked(ID_MENU_SHOW_HIDDEN,!popup3->isItemChecked(ID_MENU_SHOW_HIDDEN));
                  updateFilterFromMenu();
                  break;
               }
//***************************************************************************************
      case ID_MENU_SHOW_SYSTEMFILES:
               {
                  popup3->setItemChecked(ID_MENU_SHOW_SYSTEMFILES,!popup3->isItemChecked(ID_MENU_SHOW_SYSTEMFILES));
                  updateFilterFromMenu();
                  break;
               }
//***************************************************************************************
		default:
					
					if((itemId >= ID_STARTMENU) && (itemId < ID_STARTMENU+100))
					{
							
							KConfig *config = kapp->getConfig();
							config->setGroup("Startmenu");
							QString s;
							int i = itemId-ID_STARTMENU;
							
							s.sprintf("MenuApp%d",i);
							QString app(config->readEntry(s,""));
							
							s.sprintf("MenuParam%d",i);
							QString p(config->readEntry(s,""));
							
							KShellProcess proc("bash");
							proc << app;
							
							// Parameter nun noch zerpflcken
							p = p.simplifyWhiteSpace();
							
							while(p.find(" ") != -1)	// solange in schleife bleiben, wei ein space vorhanden
							{					
								int pos = p.find(" "); 					// Stelle mit Space finden
								QString temp(p.left(pos));				// temp wird JETZT bergeben
								p = p.right(p.length()-pos-1);  // der Rest weniger Space bleibt in Param
								insertParam(temp,&proc);
							}
							insertParam(p,&proc);
							proc.start(KProcess::DontCare,KProcess::All);
					}
					else
					{
						QString s;
						s.sprintf("Men [%d] unbekannt !!!",itemId);
//						debug(s);
						break;
					}
	}
}

//***************************************************************************************
void KCommanderApp::menuPressed()
{
}


//***************************************************************************************
void KCommanderApp::driveActivated(const char *s)
{
	QString send = sender()->name();
	QString ss,temp;
	ss = s;
	ss = ss.right(ss.length()-1);
	ss = ss.left(ss.length()-1);
   if(send == "0")
   {
      readDir(ss, linkerListView);
   	linkerListView->setFocus();
   }
	else
   {
      readDir(ss, rechterListView);
   	rechterListView->setFocus();
   }
	return;
}

//***************************************************************************************
void KCommanderApp::LVcolums()
{
	// Columbreiten wurden verndert !!
/*
	listView *lv = (listView *)sender();
	listView *destlv;

	if(lv == linkerListView)	// wenn Signal vom linken LV kam
		destlv = rechterListView;
	else
		destlv = linkerListView;
	for(int i=0;i<linkerListView->colums;i++)
		destlv->columWidth[i] = lv->columWidth[i];
	destlv->refreshColums(0);
*/
}
//***************************************************************************************
void	KCommanderApp::LVgotFocus()
{
	QString s = sender()->name();
	if(s == "lv2")
	{
		if(listWithFocus == rechterListView)
		   return;
		leftDirButton->setPalette(QPalette(*cg2,*cg2,*cg2));
		rightDirButton->setPalette(QPalette(*cg1,*cg1,*cg1));
		commandLineLabel->setText(netPathToRealPath(rightDirPath));
		listWithFocus = rechterListView;
	}
	else
	{
		if(listWithFocus == linkerListView)
		   return;
		rightDirButton->setPalette(QPalette(*cg2,*cg2,*cg2));
		leftDirButton->setPalette(QPalette(*cg1,*cg1,*cg1));
		commandLineLabel->setText(netPathToRealPath(leftDirPath));
		listWithFocus = linkerListView;
	}

	updateMenuFromFilter();
}
//***************************************************************************************
void	KCommanderApp::LVlostFocus()
{
}
//***************************************************************************************
void	KCommanderApp::buttonLeistePressed()
{
	QString key;
	QPushButton *s = (QPushButton *)sender();
	key = s->text();
	key = key.left(2);
	LVkeyPressed(key);
}
//***************************************************************************************
void	KCommanderApp::itemSelected()
{
	int a;
	QString ss;
	 	// aus beiden Listen das erste Item deselectieren (..)

	 	listItem *l = linkerListView->Liste;
	 	if(!l)
	 	   goto rightSite;

	 	
	 	linkerListView->Liste->selected = false;
	 	int sel_bytes,count_bytes;
	 	sel_bytes = count_bytes = 0;
	 	while(l)
	 	{
	 		if(l->selected)
	 			sel_bytes += atoi(*l->text[1]);	// selektierte files
	 		count_bytes += atoi(*l->text[1]);	// gesamtbytes
	 		l = l->next;
	 	}
	 	a = linkerListView->itemsSelected();
		ss.sprintf(i18n("%d / %d selected Files (%d / %d Bytes)"),a,linkerListView->itemCount-1,sel_bytes,count_bytes);
		leftSelLabel->setText(ss);
//		leftDirButton->setText(leftDirPath);
				
rightSite:
//	 	if(rechterListView->list_service == SERVICE_NETWORK)
//	 	   return;
	 	l = rechterListView->Liste;
	 	if(!l)
	 	   return;
	 	rechterListView->Liste->selected = false;
	 	sel_bytes = count_bytes = 0;
	 	while(l)
	 	{
	 		if(l->selected)
	 			sel_bytes += atoi(*l->text[1]);	// selektierte files
	 		count_bytes += atoi(*l->text[1]);	// gesamtbytes
	 		l = l->next;
	 	}
	 	a = rechterListView->itemsSelected();
		ss.sprintf(i18n("%d / %d selected Files (%d / %d Bytes)"),a,rechterListView->itemCount-1,sel_bytes,count_bytes);
		rightSelLabel->setText(ss);
//		rightDirButton->setText(rightDirPath);
}
//***************************************************************************************
void	KCommanderApp::itemDeSelected(const char *s,const char *n)
{
	itemSelected();
}

//***************************************************************************************
void KCommanderApp::commandBoxActivated()
{
	KProcess proc;
	QString s,d;
	int z;

	QDir::setCurrent(commandLineLabel->text());	
	
	s = commandBox->currentText();
	commandBox->setEditText("");
	proc << "xterm" << "-e";
	z = s.find(" ");
	if (z != -1)
	{
	while(z != -1)
		{
			z = s.find(" ");
			d = s.left(z);
			s = s.right(s.length()-(z+1));
			proc << d;
		}
	 } else proc << s;
	QApplication::connect(&proc, SIGNAL(processExited(KProcess *)), this, SLOT(slotExamine(KProcess *)));
	proc.start(KProcess::DontCare,KProcess::All);

}
//***************************************************************************************
void	KCommanderApp::slotExamine(KProcess *proc)
{
	eingehangen = true;
	SMB_READY = true;
}
//***************************************************************************************
void	KCommanderApp::receivedStdout (KProcess *proc, char *buffer, int buflen)
{
}
//***************************************************************************************
void	KCommanderApp::receivedStderr (KProcess *proc, char *buffer, int buflen)
{
	QString s = buffer;
	s = s.left(buflen);
	s = s.simplifyWhiteSpace();
   if(s.find("mount:") != -1 )
   {
      // Error of mounting devices ( SMB or NORMAL )
		QMessageBox::warning( this, i18n("Mounting Problem"),s );
      debug(s);
   }
   else
      debug(s);
   eingehangen = true;
   SMB_READY = true;
}
//***************************************************************************************
void KCommanderApp::drivePopupActivated ( int akey) // akey is a key betwen A and Z
{
	KConfig *config = kapp->getConfig();
	config->setGroup("Assignments");
	QString path;
	QString titel2;

   QString s;
   s.sprintf("DriveAssign%c", akey + 'A');
	path = config->readEntry(s,"");
   if(path == "")
      return;
   path += "/";
   s = sender()->name();
   if(s == "1")
   {
      readDir(path,linkerListView);
      leftDirPath = path;
      leftDirButton->setText(path);
   }
   else
   {
      readDir(path,rechterListView);
      rightDirPath = path;
      rightDirButton->setText(path);
   }
   linkerListView->shiftItem = 0;
   rechterListView->shiftItem = 0;
         	
}
//***************************************************************************************
void KCommanderApp::updateFilterFromMenu()
{
   bool DIRS         = popup3->isItemChecked(ID_MENU_SHOW_DIRS);
   bool FILES        = popup3->isItemChecked(ID_MENU_SHOW_FILES);
   bool HIDDEN       = popup3->isItemChecked(ID_MENU_SHOW_HIDDEN);
   bool SYSTEMFILES  = popup3->isItemChecked(ID_MENU_SHOW_SYSTEMFILES);

   int newFilter = QDir::Drives | QDir::Modified;

   newFilter += DIRS * QDir::Dirs;
   newFilter += FILES * QDir::Files;
   newFilter += HIDDEN * QDir::Hidden;
   newFilter += SYSTEMFILES * QDir::System;
   listWithFocus->dirFilter = newFilter;
   readDir(listWithFocus->dirPath, listWithFocus);
}
//***************************************************************************************
void KCommanderApp::updateMenuFromFilter()
{
   int filter = listWithFocus->dirFilter;  // get the current filter
   if(filter & QDir::Dirs)
      popup3->setItemChecked(ID_MENU_SHOW_DIRS,true);
   else
      popup3->setItemChecked(ID_MENU_SHOW_DIRS,false);

   if(filter & QDir::Files)
      popup3->setItemChecked(ID_MENU_SHOW_FILES,true);
   else
      popup3->setItemChecked(ID_MENU_SHOW_FILES,false);

   if(filter & QDir::Hidden)
      popup3->setItemChecked(ID_MENU_SHOW_HIDDEN,true);
   else
      popup3->setItemChecked(ID_MENU_SHOW_HIDDEN,false);

   if(filter & QDir::System)
      popup3->setItemChecked(ID_MENU_SHOW_SYSTEMFILES,true);
   else
      popup3->setItemChecked(ID_MENU_SHOW_SYSTEMFILES,false);

}
//***************************************************************************************
void KCommanderApp::toolButtonPressed(int bt)
{
//   debug("hallo");

   int button = (bt - TOOLBUTTON) / 10;
   if(buttonBar[button]->btExec == "cmdNETWORK")
   {
//		debug("Network einlesen");
		readDir("//",listWithFocus);
      return;
   }
   if(buttonBar[button]->btExec == "cmdSWAP_LV")
   {
//   	debug("hier geht noch");
   	LVkeyPressed("^U");
      return;
   }
   if(buttonBar[button]->btExec == "cmdDISCUSAGE")
   {
   	LVkeyPressed("^L");
      return;
   }
   if(buttonBar[button]->btExec == "cmdREAD_DIR")
   {
      readDir(buttonBar[button]->btParam,listWithFocus);
      return;
   }
   if(buttonBar[button]->btExec == "cmdEDITFILE")
   {
      return;
   }
   if(buttonBar[button]->btExec == "cmdSHOWFILE")
   {
      return;
   }
   if(buttonBar[button]->btExec == "cmdQUIT")
   {
   	close();
      return;
   }
		KProcess proc;
		proc << buttonBar[button]->btExec;
		proc.start(KProcess::DontCare,KProcess::All);
}
