
#ifndef OPTIONEN_H
#define OPTIONEN_H
#include "kcommander.h"

/**
  *@author delta_x
  */

class optionen {
public: 
	optionen();
	~optionen();
//****************************************************************************	
	// Fragen nach files lschen
	static bool	askDelete()
	{
		bool f;	
		KConfig *config;
		config = kapp->getConfig();
	  config->setGroup("Abfragen");
		QString s = config->readEntry("delete files","yes");
		if(s == "yes")
			f = true;
		else 
			f = false;
		return f;
	};
	
//****************************************************************************	
	// fragen nach files berschreiben
	static bool	askOverwrite()
	{
		bool f;	
		KConfig *config;
		config = kapp->getConfig();
	  config->setGroup("Abfragen");
		QString s = config->readEntry("overwrite files","yes");
		if(s == "yes")
			f = true;
		else 
			f = false;
		return f;
	};
//****************************************************************************	
	// fragen nach files berschreiben
	static bool	askExit()
	{
		bool f;	
		KConfig *config;
		config = kapp->getConfig();
	  config->setGroup("Abfragen");
		QString s = config->readEntry("exit commander","yes");
		if(s == "yes")
			f = true;
		else 
			f = false;
		return f;
	};
	
//****************************************************************************	
	// fragen nach Packen im Hinter oder Vordergrund
	enum Packmode{ External = 0, Normal, Ask};
	static int askPack()
	{
		int f=0;
		KConfig *config;
		config = kapp->getConfig();
	  config->setGroup("Packer");
		QString s = config->readEntry("Wo Packen","extern");
		if(s == "extern")
			f = External;
		if(s == "normal")
			f = Normal;
		if(s == "fragen")
			f = Ask;
		return f;
	};
//****************************************************************************	
	// fragen nach Packer
	static QString askPacker()
	{
		KConfig *config;
		config = kapp->getConfig();
	  config->setGroup("Packer");
		QString s = config->readEntry("Methode","gzip");
		return s;
	};

//****************************************************************************	
	// Mimetypes raussuchen
	static QString getMimeType(const char *filename)
	{
//		char buffer[1024];
		QString extender = filename;		// jetzt extender abschneiden
		extender.lower();
		int pos = 0;
		for(int i=extender.length()-1;i> -1;i--)
		{
			if(extender.mid(i,1) == ".")
			{
				pos = i;
				break;
			}
			if(extender.mid(i,1) == "/")
				if(!pos)	// wenn pos bishier noch 0 ist, dann zurck OHNE Endung
					return("");
		}
  		extender = extender.mid(pos+1,extender.length()-pos-1);
  		return extender;
		
	};
//****************************************************************************	
	// Programm suchen fr Mimetype
	static QString getMimeProg(const char *endung)
	{
		QString s,x,prog;
		KConfig *config = kapp->getConfig();
		config->setGroup("MimeTypes");
		int i = 0;
		bool flag = true;
		do
		{
			s.sprintf("Extender%d",i);
			if(!config->hasKey(s))
			{
				return("");
			}
			x = config->readEntry(s);
			s.sprintf("start with%d",i);
			prog = config->readEntry(s);
			if(strcmp(x,endung) == 0)	// gefunden !
				return prog;
			i++;
		}
		while(flag);
		return("");
	}

//****************************************************************************	
	// Permissions suchen
	static int getFilePermission(const char *filename)
	{
		struct stat sBuffer;
		int i;
		i = stat(filename,&sBuffer);
		return sBuffer.st_mode;
	}

};

#endif



