
#include "aboutwindow.h"
#include "Iconfiles/madekdev.xpm"
#include <kurllabel.h>

aboutwindow::aboutwindow(QWidget *parent, const char *name) : QDialog(parent,name,true)
{
	setCaption(i18n("About KCommander"));
	resize(500,350);
	setMinimumSize(500,350);
	setMaximumSize(500,350);
	pingu = new QLabel(this,"movie");
	pingu->setPixmap(QPixmap((const char **)madekdev));
	pingu->setGeometry(150,10,200,60);
	

	me = new QMultiLineEdit(this);
	me->setGeometry(10,80,480,210);
	me->setReadOnly(true);
	me->append(QString("KCommander"));
	me->append("*********************************\n");
	me->append("News:");
	me->append("Pathmappings to Hotkeys (SHIFT+F1 or SHIFT+F2)");
	me->append("Drag'n Drop Filecopy (ALPHA Stage!!)");
	me->append("Hotkeys for Sortorder (CTRL 1-4)");
	me->append("Swedish Language added");
	me->append("--> Welcome to our group: rjan Lindbergh (Sweden)");
	me->append("");
	me->append("For other changes please read the");
	me->append("CHANGELOG file");
	QPushButton *ok;
	ok = new QPushButton(this);
	ok->setGeometry(10,310,60,20);
	ok->setText("&OK");
	connect(ok,SIGNAL(clicked()),this,SLOT(accept()));
	KURLLabel *url;
	url = new KURLLabel(this);
	url->setText("HTTP://WWW.LinuxCoding.DE");
	url->setURL("http://www.LinuxCoding.de");
	url->setGeometry(90,310,200,30);
	connect(url,SIGNAL(leftClickedURL()),this,SLOT(goToURL()));
	

}
aboutwindow::~aboutwindow()
{
	delete pingu;
	delete me;
}


void aboutwindow::goToURL()
{
	KShellProcess proc("bash");
	proc << "kfmclient" << "openURL"	<< "http://www.LinuxCoding.de";
	proc.start(KProcess::DontCare,KProcess::All);
}
