//***************************************************************
// dlgjoin.h
//***************************************************************

#ifndef DLGJOIN_H
#define DLGJOIN_H

#include <qwidget.h>
#include <progress.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qdialog.h>
#include "kcommander.h"

/**
  *@author delta_x
  */

class dlgJoin : public QDialog  {
   Q_OBJECT
public: 
	dlgJoin(QWidget *parent=0, const char *name=0);
	~dlgJoin();

protected: 
	void			initDialog();
	myProgress 	*KProgress_1;
	QPushButton *QPushButton_1;
	QPushButton *QPushButton_2;
	QLabel 		*lbDestdir;
	QLabel 		*lbJoinedsize;
	QLabel 		*lbDir;
	QLabel 		*lbSize;
	QCheckBox	*checkBox;
	listView		*slv,
					*dlv;
	int 			message;
	bool 			progress;
	uint 			sourcesize,
					destsize;
private slots:
	void			timerEvent(QTimerEvent *);
	void			cancelPressed();
	void			startPressed();
};

#endif
