#include <kapp.h>
#include <kaccel.h>
#include <qtooltip.h>
#include <qpixmap.h>
#include "hexview.h"
#include	"up.xpm"
#include	"down.xpm"

void  Hexview::initDialog(){
  this->resize(665,390);
  this->setMaximumWidth(675);
  this->setMinimumWidth(675);

  pixUp = new QPixmap((const char **)up);
  pixDown = new QPixmap((const char **)down);

  QPushButton_2= new QPushButton(this,"NoName");
  QPushButton_2->setGeometry(640,11,20,50);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setFixedSize(20,50);
  QToolTip::add(QPushButton_2,i18n("page up"));
  QPushButton_2->setPixmap(QPixmap("up.xpm"));
	connect(QPushButton_2,SIGNAL(clicked()),SLOT(page_up()));

  QPushButton_3= new QPushButton(this,"NoName");
  QPushButton_3->setGeometry(640,330,20,50);
  QPushButton_3->setMinimumSize(0,0);
  QPushButton_3->setFixedSize(20,50);
  QToolTip::add(QPushButton_3,i18n("page down"));
  QPushButton_3->setPixmap(QPixmap("down.xpm"));
	connect(QPushButton_3,SIGNAL(clicked()),SLOT(page_down()));

  KSeparator_14= new KSeparator(this,"NoName");
  KSeparator_14->setGeometry(400,10,10,370);
  KSeparator_14->setMinimumSize(0,0);
  KSeparator_14->setOrientation(KSeparator::VLine);

  QPopupMenu_1 = new QPopupMenu();
  id = QPopupMenu_1->insertItem(i18n("&F3 Quit..."),this,SLOT(menuPressed()), 0,10110);
  QPopupMenu_1->setItemEnabled(id,false);
  id = QPopupMenu_1->insertItem(i18n("Style.."),this,SLOT(menuPressed()), 0,10120);
  QPopupMenu_1->setItemEnabled(id,false);
  id = QPopupMenu_1->insertItem(i18n("&F4 Text-View.."),this,SLOT(menuPressed()), 0,10130);
  QPopupMenu_1->setItemEnabled(id,false);
	connect(QPopupMenu_1,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
	
//	QPopupMenu_1->exec(this->mapToGlobal(QPoint(0,0)));

  QPushButton_3->setAccel(Key_PageDown);
  QPushButton_2->setAccel(Key_PageUp);
}
