
#ifndef WDGDRIVESPACE_H
#define WDGDRIVESPACE_H

#include <qwidget.h>
#include <qlabel.h>
#include "listview.h"
#include <qmultilinedit.h>

/**
  *@author delta_x
  */

class wdgDriveSpace : public QWidget  {
   Q_OBJECT
public: 
	wdgDriveSpace(listView *,QWidget *parent=0, const char *name=0);
	~wdgDriveSpace();
   void setPath(const char *);
   QWidget     *main;
   void        showInfoFile();
private slots:
   void        timerEvent(QTimerEvent *);
   void        slotExamine();
   void        receivedStdout(KProcess *p,char *buffer,int buflen);
   void        receivedStderr(KProcess *p,char *buffer,int buflen);
   void        paintEvent(QPaintEvent *);
private:
   void        draw();
   listView    *lv;
   QString     path;
   QLabel      *lb1,
               *lb2,
               *lb3,
               *lb4,
               *lb5,
               *lb6,
               *lb7;
   QLabel      *l1,
               *l2,
               *l3,
               *l4,
               *l5,
               *l6,
               *l7;
   bool        ready;
   char        *zeilen[20];
   QString     spalten[20];
   int         prozent;
   QMultiLineEdit *me;
};

#endif
